function [Up,Ang,fx]=best_feature(J,XF,f)
% LICENSE CONDITIONS
% ==================================
% 
% Copyright   2012   The Regents of the University of California
% All Rights Reserved
% 
% Permission to use, copy, modify and distribute any part of this 
% code for training multicalss classifers for educational, research 
% and non-profit purposes, without fee, and without a written 
% agreement is hereby granted, provided that the above copyright 
% notice, this paragraph and the following three paragraphs appear 
% in all copies.
% 
% Those desiring to incorporate this code for MCBoost(GD or CD )
% into commercial products or use for commercial purposes 
% should contact the Technology Transfer & Intellectual Property 
% Services, University of California, San Diego, 9500 Gilman Drive, 
% Mail Code 0910, La Jolla, CA 92093-0910, Ph: (858) 534-5815, 
% FAX: (858) 534-7345, E-MAIL:invent@ucsd.edu.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE 
% TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, 
% OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, 
% ARISING OUT OF THE USE OF THIS CODE FOR MCBOOST,  
% EVEN IF THE UNIVERSITY OF CALIFORNIA 
% HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% 
% THE CODE FOR MCBOOST PROVIDED 
% HEREIN IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF 
% CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
% SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.  
% THE UNIVERSITY OF CALIFORNIA MAKES NO REPRESENTATIONS 
% AND EXTENDS NO WARRANTIES OF ANY KIND, EITHER IMPLIED 
% OR EXPRESS, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
% WARRANTIES OF MERCHANTABILITY OR FITNESS FOR 
% A PARTICULAR PURPOSE, OR THAT THE USE OF THE 
% CODE FOR DISCRIMINANT SALIENCY TRACKER WILL NOT 
% INFRINGE ANY PATENT, TRADEMARK OR OTHER RIGHTS.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

J=-J';
step=0.01;
d=size(f,2);
thre=(floor(min(min(XF)))-0.5):step:(floor(max(max(XF)))+1.5);
res=length(thre);  
 
wr=repmat(J,1,res); 
ll=length(XF);


th=repmat(thre,ll,1);
%==========================================================================
%find the best threshold for each classifier
for i=1:1:d
    Hist=(XF*f(:,i));                    %histogram of all points
    parity(i)=1;                         %parity show faces are above or below threshold]
    Hist=repmat(Hist,1,res); 
    U=(((Hist-th)>=0)-((Hist-th)<0));  
    L=sum(wr.*U);
    L1=-L;
    [p,q]=min(L);
    [p1,q1]=min(L1);
    if p1<p
        parity(i)=-1; 
        q=q1; 
        p=p1; 
    end 
    Loss(i)=p; 
    thr(i)=thre(q);
end 
Loss=Loss+(Loss==0)*10000;
%==========================================================================
[p,q]=min(Loss);
Ang=acos(-p/(sqrt(sum(J.^2)*length(Hist))))*(180/pi);
Up.num=q; 
Up.thr=thr(q);  
Up.c=parity(q);
Up.b=0;
Hist=XF*f(:,Up.num); 
fx=Up.c*(((Hist-thr(q))>=0)-((Hist-thr(q))<0));  
