function res=J_comp_alpha_MW(f_val,Z_lab,Yc,j,fx,alpha)
% LICENSE CONDITIONS
% ==================================
% 
% Copyright   2012   The Regents of the University of California
% All Rights Reserved
% 
% Permission to use, copy, modify and distribute any part of this 
% code for training multicalss classifers for educational, research 
% and non-profit purposes, without fee, and without a written 
% agreement is hereby granted, provided that the above copyright 
% notice, this paragraph and the following three paragraphs appear 
% in all copies.
% 
% Those desiring to incorporate this code for MCBoost(GD or CD )
% into commercial products or use for commercial purposes 
% should contact the Technology Transfer & Intellectual Property 
% Services, University of California, San Diego, 9500 Gilman Drive, 
% Mail Code 0910, La Jolla, CA 92093-0910, Ph: (858) 534-5815, 
% FAX: (858) 534-7345, E-MAIL:invent@ucsd.edu.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE 
% TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, 
% OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, 
% ARISING OUT OF THE USE OF THIS CODE FOR MCBOOST,  
% EVEN IF THE UNIVERSITY OF CALIFORNIA 
% HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% 
% THE CODE FOR MCBOOST PROVIDED 
% HEREIN IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF 
% CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
% SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.  
% THE UNIVERSITY OF CALIFORNIA MAKES NO REPRESENTATIONS 
% AND EXTENDS NO WARRANTIES OF ANY KIND, EITHER IMPLIED 
% OR EXPRESS, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
% WARRANTIES OF MERCHANTABILITY OR FITNESS FOR 
% A PARTICULAR PURPOSE, OR THAT THE USE OF THE 
% CODE FOR DISCRIMINANT SALIENCY TRACKER WILL NOT 
% INFRINGE ANY PATENT, TRADEMARK OR OTHER RIGHTS.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
J=0;
for k=1:size(Z_lab,3)
    if size(f_val,1)==1
        EB1=(f_val.*Z_lab(:,:,k));
    else
        EB1=sum(f_val.*Z_lab(:,:,k));
    end
    
    if size(fx,1)==1
        EB3=(fx.*Z_lab(:,:,k));
    else
        EB3=sum(fx.*Z_lab(:,:,k));
    end
    
    Z_x=Z_lab(:,:,k);
    Temp=Yc'.*exp(-EB1).*exp(-alpha*EB3);
    T_x=repmat(Temp,size(Z_x,1),1);
    EB2=Z_x.*T_x;
    J=J+EB2;
end

res=-sum(sum(fx.*J));