function T=build_tree_ERR_MW(T,XF,Y,w,depth,ind,f,N_r_search,val,Y_disp)
% LICENSE CONDITIONS
% ==================================
% 
% Copyright   2012   The Regents of the University of California
% All Rights Reserved
% 
% Permission to use, copy, modify and distribute any part of this 
% code for training multicalss classifers for educational, research 
% and non-profit purposes, without fee, and without a written 
% agreement is hereby granted, provided that the above copyright 
% notice, this paragraph and the following three paragraphs appear 
% in all copies.
% 
% Those desiring to incorporate this code for MCBoost(GD or CD )
% into commercial products or use for commercial purposes 
% should contact the Technology Transfer & Intellectual Property 
% Services, University of California, San Diego, 9500 Gilman Drive, 
% Mail Code 0910, La Jolla, CA 92093-0910, Ph: (858) 534-5815, 
% FAX: (858) 534-7345, E-MAIL:invent@ucsd.edu.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE 
% TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, 
% OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, 
% ARISING OUT OF THE USE OF THIS CODE FOR MCBOOST,  
% EVEN IF THE UNIVERSITY OF CALIFORNIA 
% HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% 
% THE CODE FOR MCBOOST PROVIDED 
% HEREIN IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF 
% CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
% SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.  
% THE UNIVERSITY OF CALIFORNIA MAKES NO REPRESENTATIONS 
% AND EXTENDS NO WARRANTIES OF ANY KIND, EITHER IMPLIED 
% OR EXPRESS, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
% WARRANTIES OF MERCHANTABILITY OR FITNESS FOR 
% A PARTICULAR PURPOSE, OR THAT THE USE OF THE 
% CODE FOR DISCRIMINANT SALIENCY TRACKER WILL NOT 
% INFRINGE ANY PATENT, TRADEMARK OR OTHER RIGHTS.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if depth<1
    return;
end

[Node,I_l,I_m]=build_one_ERR_MW(XF,Y,w,f,N_r_search,val,Y_disp);
T(ind)=Node;
if length(I_l)>0
    XFl=XF(I_l,:);
    Yl=Y(I_l);
    wl=w(I_l,:);
    T=build_tree_ERR_MW(T,XFl,Yl,wl,depth-1,2*ind,f,N_r_search,Node.less,Y_disp);
end

if length(I_m)>0
    XFm=XF(I_m,:);
    Ym=Y(I_m);
    wm=w(I_m,:);
    T=build_tree_ERR_MW(T,XFm,Ym,wm,depth-1,2*ind+1,f,N_r_search,Node.more,Y_disp);
end

