function [Node,I_l,I_m]=build_one_ERR(XF,Y,w,f,N_r_search,val,Y_disp)
% LICENSE CONDITIONS
% ==================================
% 
% Copyright   2012   The Regents of the University of California
% All Rights Reserved
% 
% Permission to use, copy, modify and distribute any part of this 
% code for training multicalss classifers for educational, research 
% and non-profit purposes, without fee, and without a written 
% agreement is hereby granted, provided that the above copyright 
% notice, this paragraph and the following three paragraphs appear 
% in all copies.
% 
% Those desiring to incorporate this code for MCBoost(GD or CD )
% into commercial products or use for commercial purposes 
% should contact the Technology Transfer & Intellectual Property 
% Services, University of California, San Diego, 9500 Gilman Drive, 
% Mail Code 0910, La Jolla, CA 92093-0910, Ph: (858) 534-5815, 
% FAX: (858) 534-7345, E-MAIL:invent@ucsd.edu.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE 
% TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, 
% OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, 
% ARISING OUT OF THE USE OF THIS CODE FOR MCBOOST,  
% EVEN IF THE UNIVERSITY OF CALIFORNIA 
% HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% 
% THE CODE FOR MCBOOST PROVIDED 
% HEREIN IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF 
% CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
% SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.  
% THE UNIVERSITY OF CALIFORNIA MAKES NO REPRESENTATIONS 
% AND EXTENDS NO WARRANTIES OF ANY KIND, EITHER IMPLIED 
% OR EXPRESS, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
% WARRANTIES OF MERCHANTABILITY OR FITNESS FOR 
% A PARTICULAR PURPOSE, OR THAT THE USE OF THE 
% CODE FOR DISCRIMINANT SALIENCY TRACKER WILL NOT 
% INFRINGE ANY PATENT, TRADEMARK OR OTHER RIGHTS.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
N=max(Y);
N_att=size(f,2);
dd=size(XF,1);
Base_Err=sum((Y_disp(:,val))'.*sum(w));
for i=1:N_att
    H=XF*f(:,i);
    r=linspace(min(H),max(H),N_r_search);
    for k=1:length(r)
        I1=find(H>r(k));
        for jj=1:N
            temp=Y;
            temp(I1)=jj;
            t_err_m(jj)=sum((Y_disp(:,jj))'.*sum(w(I1,:)));
        end
        [temp_err_m(k),temp_lab_m(k)]=max(t_err_m);
        
        I2=find(H<=r(k));
        for jj=1:N
            temp=Y;
            temp(I2)=jj;
            t_err_l(jj)=sum((Y_disp(:,jj))'.*sum(w(I2,:)));
        end
        [temp_err_l(k),temp_lab_l(k)]=max(t_err_l);
        err_k(k)=temp_err_l(k)+temp_err_m(k);
    end
    [err_gain(i),q]=max(err_k);
    thr(i)=r(q);
    lab_m(i)=temp_lab_m(q);
    lab_l(i)=temp_lab_l(q);
end
[p,q]=max(err_gain);

Node.att=q;
Node.thr=thr(q);
Node.more=lab_m(q);
Node.less=lab_l(q);
Node.empt=0;

H=XF*f(:,Node.att);
I_m=find(H>Node.thr);
a_1=sum((Y_disp(:,Node.more))'.*sum(w(I_m,:)));
I_l=find(H<=Node.thr);
a_2=sum((Y_disp(:,Node.less))'.*sum(w(I_l,:)));